/*****************************************************************************
**
** program_ugnx3_critical_projection_angle.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.

       IPAC
       
     
 X      
 Y      
 Z  
     YZ  ZX
  prterr.txt    

 .. 19  2006 

22         
23     406

**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif




#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_modl.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_disp.h>
#include <uf_curve.h>
#include <uf_part.h>



static	FILE*		prterr;
static	int			errorCode;




#define PRTERR(line)if(errorCode){PrintErrorMessage(errorCode,line);\
	errorCode=0;goto term;}






static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
	}
}




int face_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_face_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}


void do_it(void)
{
	tag_t
		face;//   


label_select_face:
// 
	{
		char*
			message=" ";
		char*
			title=" ";
		int
			scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int
			response;
		tag_t
			object;
		double
			cursor[3];
		tag_t
			view;

		errorCode=UF_UI_select_with_single_dialog
			(message,title,scope,face_init_proc,NULL,&response,&object,cursor,&view);
		PRTERR(__LINE__);

		switch(response)
		{
		case UF_UI_BACK:
			goto label_select_face;
		case UF_UI_CANCEL:
			goto term;
		case UF_UI_OK:
			break;
		case UF_UI_OBJECT_SELECTED:
			break;
		case UF_UI_OBJECT_SELECTED_BY_NAME:
			break;

		}

		if(object==NULL_TAG)
		{
			uc1601(" ,  !",1);
			goto label_select_face;
		}

		errorCode=UF_DISP_set_highlight(object,0);
		PRTERR(__LINE__);

		face=object;

	}



	
	struct	data_record
	{
		double	point[3];
		double	normv[3];
		double	projX[3];
		double	projY[3];
		double	angle;
	};


	static	struct	data_record		arr_pv[30000];
	
	int
		pnt_count=0;


// 
	{

		double
			uv_min_max[4];
					/*	
		[0]-umin
		[1]-umax
		[2]-vmin
		[3]-vmax
					*/
		
		// min, max  u,v  
		errorCode=UF_MODL_ask_face_uv_minmax(face,uv_min_max);
		PRTERR(__LINE__);

		fprintf(prterr,"umin=%f	umax=%f		vmin=%f		vmax=%f\n",
			uv_min_max[0],uv_min_max[1],uv_min_max[2],uv_min_max[3]);
		

		
		int
			pt_status,
			p_number=170,
			i,j;

		double
			u_step,
			v_step;

		double
			param[2],point[3],u1[3],v1[3],u2[3],v2[3],unit_norm[3],radii[2];

		char
			msg[100];


		u_step=(uv_min_max[1]-uv_min_max[0])/(p_number-1);
		v_step=(uv_min_max[3]-uv_min_max[2])/(p_number-1);

		//   ,   
		for(i=0;i<p_number;i++)
		{
			for(j=0;j<p_number;j++)
			{
				//      
				
				param[0]=uv_min_max[0]+i*u_step;
				param[1]=uv_min_max[2]+j*v_step;
				
				// !!!       
				//        
				//     
				errorCode=UF_MODL_ask_face_props
					(face,param,point,u1,v1,u2,v2,unit_norm,radii);
				PRTERR(__LINE__);

				
				//  ?

				errorCode=UF_MODL_ask_point_containment(point,face,&pt_status);
				PRTERR(__LINE__);

				if(pt_status==1 || pt_status==3)
					
					//       
					//      
					//    
				{
					
					UF_VEC3_copy(point,arr_pv[pnt_count].point);
					UF_VEC3_copy(unit_norm,arr_pv[pnt_count].normv);
					pnt_count++;


				}

			}

			//      i
			sprintf(msg,"       %6.2f%%",
				(double)100.0*i/(p_number-1));
			errorCode=UF_UI_set_status(msg);PRTERR(__LINE__);
		}

		fprintf(prterr,"pnt_count=%d\n",pnt_count);

/*
		tag_t
			pnt_tag;

		UF_CURVE_line_t		
			line_coords;

		tag_t				
			line;


		for(i=0;i<pnt_count;i++)
		{
			
			UF_VEC3_copy(arr_pv[i].point,line_coords.start_point);


			UF_VEC3_add(arr_pv[i].point,arr_pv[i].normv,line_coords.end_point);
			
			errorCode=UF_CURVE_create_line (&line_coords,&line );PRTERR(__LINE__):

			
		}

*/

	}
// -----------------------------------------------------



/*	


	 

	1.	      YZ
	2.	    OZ    
		      YZ
	3.	     OZ    
		      YZ
	4.	     OZ    
		      YZ
	5.	         
		  OZ    
		      YZ


*/


//     YZ
//    OZ

	{
		/*
		
		1.      
		2.      
		3.     
		4.     Z
		
		*/
		
		int
			i;
		double
			end_normv[3],
			proj_normv[3],
			proj_point[3],
			proj_vectr[3];
		double
			axe_X[3]={1,0,0},
			axe_Z[3]={0,0,1};

		for(i=0;i<pnt_count;i++)
		{

			//     ,    ,
			//          

			UF_VEC3_add(arr_pv[i].point,arr_pv[i].normv,end_normv);
			
			//1.      
			errorCode=UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,end_normv,UF_CSYS_ROOT_WCS_COORDS,proj_normv);
			PRTERR(__LINE__);
			//      YZ   
			//x=0
			proj_normv[0]=0;

			//2.      
			errorCode=UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,arr_pv[i].point,UF_CSYS_ROOT_WCS_COORDS,proj_point);
			PRTERR(__LINE__);
			//      YZ    
			//x=0
			proj_point[0]=0;

			//3.      ,    
			UF_VEC3_sub(proj_normv,proj_point,proj_vectr);

			//4.     OZ
			UF_VEC3_angle_between(axe_Z,proj_vectr,axe_X,&(arr_pv[i].angle));
			if(arr_pv[i].angle>PI)
				arr_pv[i].angle=arr_pv[i].angle-2*PI;

			//     YZ, 
			//     
			UF_VEC3_copy(proj_vectr,arr_pv[i].projX);
		
		}



	}




	//      YZ
	{

		int
			max_i=0;
		double
			max_angle_YZ=0;

		int
			i;

		for(i=0;i<pnt_count;i++)
			if(max_angle_YZ < arr_pv[i].angle)
			{
				max_angle_YZ=arr_pv[i].angle;
				max_i=i;
			}

		//    
		//    YZ

		
		double
			point_yz[3],
			projYZ[3],
			unit_vec[3],
			tolerance=0.001,
			magnitude;//200=magnitude*vec_length
			
		
		//   arr_pv[max_i].projX  
		errorCode=UF_VEC3_unitize
			(arr_pv[max_i].projX,tolerance,&magnitude,unit_vec);

		//   
		if(errorCode)
		{
			projYZ[0]=0;
			projYZ[1]=0;
			projYZ[2]=200;
		}
		else
			UF_VEC3_scale(200,unit_vec,projYZ);


		//     
		//   point_yz
		//UF_CSYS_ROOT_COORDS is the ABS of the displayed part
		//UF_CSYS_ROOT_WCS_COORDS is the WCS of the displayed part

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,arr_pv[max_i].point,
			UF_CSYS_ROOT_WCS_COORDS,point_yz);
		PRTERR(__LINE__);

		//    projYZ   point_yz
		UF_VEC3_add(point_yz,projYZ,projYZ);
		
		
		double
			vertex1[3],
			vertex2[3],
			vertex3[3],
			vertex4[3];
		
		
		//     
		vertex1[0]=projYZ[0];
		vertex1[1]=projYZ[1]+20;
		vertex1[2]=projYZ[2]+20;

		UF_VEC3_copy(vertex1,vertex2);
		vertex2[2]=vertex2[2]-40;

		UF_VEC3_copy(vertex2,vertex3);
		vertex3[1]=vertex3[1]-40;

		UF_VEC3_copy(vertex3,vertex4);
		vertex4[2]=vertex2[2]+40;

		double
			work_zero[3]={0,0,0},
			work_zero_to_abs[3];

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,work_zero,
			UF_CSYS_ROOT_COORDS,work_zero_to_abs);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex1,
			UF_CSYS_ROOT_COORDS,vertex1);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex2,
			UF_CSYS_ROOT_COORDS,vertex2);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex3,
			UF_CSYS_ROOT_COORDS,vertex3);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex4,
			UF_CSYS_ROOT_COORDS,vertex4);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,projYZ,
			UF_CSYS_ROOT_COORDS,projYZ);
		PRTERR(__LINE__);


		UF_CURVE_line_t
			line_coords;
		tag_t
			line;

		//    
		UF_VEC3_copy(arr_pv[max_i].point,line_coords.start_point);
		UF_VEC3_copy(projYZ,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		//    
		//     
		UF_VEC3_copy(vertex1,line_coords.start_point);
		UF_VEC3_copy(vertex2,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex2,line_coords.start_point);
		UF_VEC3_copy(vertex3,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		UF_VEC3_copy(vertex3,line_coords.start_point);
		UF_VEC3_copy(vertex4,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex4,line_coords.start_point);
		UF_VEC3_copy(vertex1,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);
	}










	//      YZ
	{

		int
			min_i=0;
		double
			min_angle_YZ=0;

		int
			i;

		for(i=pnt_count-1;i>-1;i--)
			if(min_angle_YZ > arr_pv[i].angle)
			{
				min_angle_YZ=arr_pv[i].angle;
				min_i=i;
			}

		//    
		//    YZ

		
		double
			point_yz[3],
			projYZ[3],
			unit_vec[3],
			tolerance=0.001,
			magnitude;//200=magnitude*vec_length
			
		
		//   arr_pv[max_i].projX  
		errorCode=UF_VEC3_unitize
			(arr_pv[min_i].projX,tolerance,&magnitude,unit_vec);

		//   
		if(errorCode)
		{
			projYZ[0]=0;
			projYZ[1]=0;
			projYZ[2]=200;
		}
		else
			UF_VEC3_scale(200,unit_vec,projYZ);


		//     
		//   point_yz
		//UF_CSYS_ROOT_COORDS is the ABS of the displayed part
		//UF_CSYS_ROOT_WCS_COORDS is the WCS of the displayed part

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,arr_pv[min_i].point,
			UF_CSYS_ROOT_WCS_COORDS,point_yz);
		PRTERR(__LINE__);

		//    projYZ   point_yz
		UF_VEC3_add(point_yz,projYZ,projYZ);
		
		
		double
			vertex1[3],
			vertex2[3],
			vertex3[3],
			vertex4[3];
		
		
		//     
		vertex1[0]=projYZ[0];
		vertex1[1]=projYZ[1]+20;
		vertex1[2]=projYZ[2]+20;

		UF_VEC3_copy(vertex1,vertex2);
		vertex2[2]=vertex2[2]-40;

		UF_VEC3_copy(vertex2,vertex3);
		vertex3[1]=vertex3[1]-40;

		UF_VEC3_copy(vertex3,vertex4);
		vertex4[2]=vertex2[2]+40;

		double
			work_zero[3]={0,0,0},
			work_zero_to_abs[3];

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,work_zero,
			UF_CSYS_ROOT_COORDS,work_zero_to_abs);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex1,
			UF_CSYS_ROOT_COORDS,vertex1);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex2,
			UF_CSYS_ROOT_COORDS,vertex2);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex3,
			UF_CSYS_ROOT_COORDS,vertex3);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex4,
			UF_CSYS_ROOT_COORDS,vertex4);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,projYZ,
			UF_CSYS_ROOT_COORDS,projYZ);
		PRTERR(__LINE__);


		UF_CURVE_line_t
			line_coords;
		tag_t
			line;

		//    
		UF_VEC3_copy(arr_pv[min_i].point,line_coords.start_point);
		UF_VEC3_copy(projYZ,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		//    
		//     
		UF_VEC3_copy(vertex1,line_coords.start_point);
		UF_VEC3_copy(vertex2,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex2,line_coords.start_point);
		UF_VEC3_copy(vertex3,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		UF_VEC3_copy(vertex3,line_coords.start_point);
		UF_VEC3_copy(vertex4,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex4,line_coords.start_point);
		UF_VEC3_copy(vertex1,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);
	}






	//     ZX
	//    OZ

	{
		/*
		
		1.      
		2.      
		3.     
		4.     Z
		
		*/
		
		int
			i;
		double
			end_normv[3],
			proj_normv[3],
			proj_point[3],
			proj_vectr[3];
		double
			axe_Y[3]={0,1,0},
			axe_Z[3]={0,0,1};

		for(i=0;i<pnt_count;i++)
		{


			//     ,    ,
			//          
			UF_VEC3_add(arr_pv[i].point,arr_pv[i].normv,end_normv);
			

			//1.      
			errorCode=UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,end_normv,UF_CSYS_ROOT_WCS_COORDS,proj_normv);
			PRTERR(__LINE__);
			//      ZX   
			//x=0
			proj_normv[1]=0;


			//2.      
			errorCode=UF_CSYS_map_point
				(UF_CSYS_ROOT_COORDS,arr_pv[i].point,UF_CSYS_ROOT_WCS_COORDS,proj_point);
			PRTERR(__LINE__);
			//      ZX    
			//x=0
			proj_point[1]=0;


			//3.      ,    
			UF_VEC3_sub(proj_normv,proj_point,proj_vectr);


			//4.     OZ
			UF_VEC3_angle_between(axe_Z,proj_vectr,axe_Y,&(arr_pv[i].angle));
			if(arr_pv[i].angle>PI)
				arr_pv[i].angle=arr_pv[i].angle-2*PI;


			//     YZ, 
			//     
			UF_VEC3_copy(proj_vectr,arr_pv[i].projY);
		

		}



	}







	//      ZX
	{

		int
			max_i=0;
		double
			max_angle_ZX=0;

		int
			i;

		for(i=0;i<pnt_count;i++)
			if(max_angle_ZX < arr_pv[i].angle)
			{
				max_angle_ZX=arr_pv[i].angle;
				max_i=i;
			}

		//    
		//    YZ

		
		double
			point_zx[3],
			projZX[3],
			unit_vec[3],
			tolerance=0.001,
			magnitude;//200=magnitude*vec_length
			
		
		//   arr_pv[max_i].projY  
		errorCode=UF_VEC3_unitize
			(arr_pv[max_i].projY,tolerance,&magnitude,unit_vec);

		//   
		if(errorCode)
		{
			projZX[0]=0;
			projZX[1]=0;
			projZX[2]=200;
		}
		else
			UF_VEC3_scale(200,unit_vec,projZX);


		//     
		//   point_zx
		//UF_CSYS_ROOT_COORDS is the ABS of the displayed part
		//UF_CSYS_ROOT_WCS_COORDS is the WCS of the displayed part

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,arr_pv[max_i].point,
			UF_CSYS_ROOT_WCS_COORDS,point_zx);
		PRTERR(__LINE__);

		//    projY   point_zx
		UF_VEC3_add(point_zx,projZX,projZX);
		
		
		double
			vertex1[3],
			vertex2[3],
			vertex3[3],
			vertex4[3];
		
		
		//     
		vertex1[0]=projZX[0]+20;
		vertex1[1]=projZX[1];
		vertex1[2]=projZX[2]+20;

		UF_VEC3_copy(vertex1,vertex2);
		vertex2[2]=vertex2[2]-40;

		UF_VEC3_copy(vertex2,vertex3);
		vertex3[0]=vertex3[0]-40;

		UF_VEC3_copy(vertex3,vertex4);
		vertex4[2]=vertex2[2]+40;

		double
			work_zero[3]={0,0,0},
			work_zero_to_abs[3];

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,work_zero,
			UF_CSYS_ROOT_COORDS,work_zero_to_abs);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex1,
			UF_CSYS_ROOT_COORDS,vertex1);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex2,
			UF_CSYS_ROOT_COORDS,vertex2);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex3,
			UF_CSYS_ROOT_COORDS,vertex3);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex4,
			UF_CSYS_ROOT_COORDS,vertex4);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,projZX,
			UF_CSYS_ROOT_COORDS,projZX);
		PRTERR(__LINE__);


		UF_CURVE_line_t
			line_coords;
		tag_t
			line;

		//    
		UF_VEC3_copy(arr_pv[max_i].point,line_coords.start_point);
		UF_VEC3_copy(projZX,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		//    
		//     
		UF_VEC3_copy(vertex1,line_coords.start_point);
		UF_VEC3_copy(vertex2,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex2,line_coords.start_point);
		UF_VEC3_copy(vertex3,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		UF_VEC3_copy(vertex3,line_coords.start_point);
		UF_VEC3_copy(vertex4,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex4,line_coords.start_point);
		UF_VEC3_copy(vertex1,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);
	}







	//      ZX
	{

		int
			min_i=0;
		double
			min_angle_ZX=0;

		int
			i;

		for(i=pnt_count-1;i>-1;i--)
			if(min_angle_ZX > arr_pv[i].angle)
			{
				min_angle_ZX=arr_pv[i].angle;
				min_i=i;
			}

		//    
		//    ZX

		
		double
			point_zx[3],	//!!!
			projZX[3],		//!!!
			unit_vec[3],
			tolerance=0.001,
			magnitude;//200=magnitude*vec_length
			
		
		//   arr_pv[max_i].projY  
		errorCode=UF_VEC3_unitize
			(arr_pv[min_i].projY,tolerance,&magnitude,unit_vec);	//!!!

		//   
		if(errorCode)
		{
			projZX[0]=0;
			projZX[1]=0;
			projZX[2]=200;
		}
		else
			UF_VEC3_scale(200,unit_vec,projZX);


		//     
		//   point_zx
		//UF_CSYS_ROOT_COORDS is the ABS of the displayed part
		//UF_CSYS_ROOT_WCS_COORDS is the WCS of the displayed part

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_COORDS,arr_pv[min_i].point,
			UF_CSYS_ROOT_WCS_COORDS,point_zx);
		PRTERR(__LINE__);

		//    projZX   point_zx
		UF_VEC3_add(point_zx,projZX,projZX);
		
		
		double
			vertex1[3],
			vertex2[3],
			vertex3[3],
			vertex4[3];
		
		
		//     
		vertex1[0]=projZX[0]+20;
		vertex1[1]=projZX[1];
		vertex1[2]=projZX[2]+20;

		UF_VEC3_copy(vertex1,vertex2);
		vertex2[2]=vertex2[2]-40;

		UF_VEC3_copy(vertex2,vertex3);
		vertex3[0]=vertex3[0]-40;

		UF_VEC3_copy(vertex3,vertex4);
		vertex4[2]=vertex2[2]+40;

		double
			work_zero[3]={0,0,0},
			work_zero_to_abs[3];

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,work_zero,
			UF_CSYS_ROOT_COORDS,work_zero_to_abs);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex1,
			UF_CSYS_ROOT_COORDS,vertex1);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex2,
			UF_CSYS_ROOT_COORDS,vertex2);
		PRTERR(__LINE__);

		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex3,
			UF_CSYS_ROOT_COORDS,vertex3);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,vertex4,
			UF_CSYS_ROOT_COORDS,vertex4);
		PRTERR(__LINE__);


		errorCode=UF_CSYS_map_point
			(UF_CSYS_ROOT_WCS_COORDS,projZX,
			UF_CSYS_ROOT_COORDS,projZX);
		PRTERR(__LINE__);


		UF_CURVE_line_t
			line_coords;
		tag_t
			line;

		//    
		UF_VEC3_copy(arr_pv[min_i].point,line_coords.start_point);
		UF_VEC3_copy(projZX,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		//    
		//     
		UF_VEC3_copy(vertex1,line_coords.start_point);
		UF_VEC3_copy(vertex2,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex2,line_coords.start_point);
		UF_VEC3_copy(vertex3,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);

		UF_VEC3_copy(vertex3,line_coords.start_point);
		UF_VEC3_copy(vertex4,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);


		UF_VEC3_copy(vertex4,line_coords.start_point);
		UF_VEC3_copy(vertex1,line_coords.end_point);
		errorCode=UF_CURVE_create_line(&line_coords,&line);
	}








term:
	fflush(prterr);
	return;

}




/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{


	//   
	struct	tm*
		newtime;
	time_t
		aclock,
		start_time,
		finish_time;
	double
		work_time;
	int
		min,sec;
	tag_t
		part;

	time(&start_time);
//----------------------------------------------------------------------------

	
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

//----------------------------------------------------------------------------	

	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    C:\\TEMP\\",1);
		goto label_clock;
	}


	uc1601("     <prterr.txt>",1);
	return;
	

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n");
	fprintf(prterr,"<critical_projection_angle>	HAS STARTED     line=%d\n\n"
		,__LINE__);
	fprintf(prterr,"   : %s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR(__LINE__); 
    

//----------------------------------------------------------------------------




	part=UF_PART_ask_display_part();
	if(!part)
	{
		uc1601(",    ",1);
		fprintf(prterr,"      line=%d\n",__LINE__);
		goto term;
	}






    /* TODO: Add your application code here */
	do_it();






    /* Terminate the API environment */
    errorCode=UF_terminate();PRTERR(__LINE__);

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n");
	fprintf(prterr,"<critical_projection_angle>	HAS FINISHED     line=%d\n\n",
		__LINE__);
	fprintf(prterr,"work_time is	%u min	%u sec\n",min,sec);

	fflush(prterr);
	fclose(prterr);


	if(UF_is_initialized())
		UF_terminate();

	return;




}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
